#include "main.h"

int Device_File_Init() {
    const char *readbuf=device_inspect();    
    //将第3个和第4个字符提取出来
    char *sub_str=malloc(3);
    sub_str[0]=readbuf[2];
    sub_str[1]=readbuf[3];
    sub_str[2]='\0';
    printf("开始初始化了");
     if(strcmp(sub_str,"02")==0){//坦克的编码
        pin_init();
        pinMode(2, OUTPUT);//pwm引脚改为普通引脚
		pinMode(21, OUTPUT);//pwm引脚改为普通引脚
        digitalWrite(2, LOW);
        digitalWrite(21, LOW);
        AppExit_pin_pwm=1;//坦克的异常停止值
        free(sub_str);
    }else if(strcmp(sub_str,"01")==0){//车的编码
        pwm_speed(); //pwm初始化，车为停止
        pin_init();
        AppExit_pin_pwm=2;//车的异常停止值
        free(sub_str);
    }else if(strcmp(sub_str,"03")==0){//船的编码
         pwm_speed();
        pin_ship_init(); //pwm初始化，车为停止
        AppExit_pin_pwm=3;//车的异常停止值
        free(sub_str);
    }
    Delay_Ms(20,0);
    TOPIC=malloc(24);
    TOPIC2=malloc(24);
    TOPIC3= malloc(16);
    sprintf(TOPIC2,"dev2app/%s",readbuf);
    sprintf(TOPIC,"app2dev/%s",readbuf);
    sprintf(TOPIC3,"%s",readbuf);
    printf("1:%s,2:%s,3:%s\n",TOPIC,TOPIC2,TOPIC3);
    return 0;
}

int main(int argc, char *argv[]) {
    if (wiringPiSetup() == -1) {
        printf("WiringPi setup failed!\n");
        return 1;
        }
    if (!INA226_begin(sda_pin, scl_pin)) {
        printf("INA226 初始化失败！\n");
        return 2;
    }
    if(Device_File_Init()!=0) {
        printf("设备文件读取初始化失败！\n");
        return 3;
    }
    system("pkill  chromium");
    // 配置 INA226
    INA226_configure(sda_pin, scl_pin);
    // 校准 INA226
    float rShuntValue = 0.1; // 分流电阻值（单位：欧姆）
    float iMaxExpected = 5; // 最大预期电流（单位：安培）
    INA226_calibrate(sda_pin, scl_pin, rShuntValue, iMaxExpected);
    gStart=time(NULL);//开始时间戳
    ipaddr();//获取ip
    thread_start(AppExit,Mqttbeat,opensh,Mqtt_onnect);//开启线程
    thread_end();
    return EXIT_SUCCESS;
}